#include "defines.h" 

typedef struct exit_struct exit_struct;
typedef struct files_struct files_struct;
typedef struct pipe_pairs pipe_pairs;
typedef struct ipc_struct ipc_struct;
typedef struct test_struct test_struct;
typedef struct child_struct child_struct;
typedef struct port_struct port_struct;
typedef struct config_struct config_struct;
typedef struct db_struct db_struct;
typedef struct dbctl_struct dbctl_struct;
typedef struct dbreq_struct dbreq_struct;
typedef struct th_struct th_struct;

struct th_struct {

	char *hostname;
	char port;

};

struct dbreq_struct {

	int id;
	int result;
	char ipaddr[16];
	int status;

};

struct db_struct {

	int rdnsfd;
	int trapfd;
	int relayfd;
	int proxyfd;
	int socksfd;
	int whitefd;
	int oklistfd;
	dbreq_struct req[MAX_REQUESTS];

} *dbinfo;

struct exit_struct {

	int socks;
	int http;
	int relay;
	int body;
	int rdns;
	int trap;

};

struct files_struct {

	char *http;
	char *rdns;
	char *smtp;
	char *sock;
	char *trap;
	char *localdb;
	char *oklist;
	char *white;

	FILE *logfp;
	FILE *errfp;

	char *logfile;
	char *errfile;

};

struct pipe_pairs {

	int log_p;
	int log_c;

	int err_p;
	int err_c;

	int stat_p;
	int stat_c;

};

struct ipc_struct {

	int children; /* number of children I have running */
	int parent; /* whether I have a parrent or not */
	int status; /* this is to keep trck of whether I am a child or parent */
	pipe_pairs **pipe;
};

struct test_struct {
	int status;
	int result;
	int type;
	int port;
	int id;
};

struct child_struct {
	int status;
	int result;
	int parent;
	int parentfd;
	int childfd;
	int id;
	int type;
	char *hostname;
	int port;
	int sockfd;

};

struct port_struct {
	int port;
	int type;
};

struct dbctl_struct {
	int parentfd;
	int childfd;
};

struct config_struct {

	char *config; /* pointer to config file buffer */
	int add_http;
	int add_rdns;
	int add_smtp;
	int add_sock;
	int add_trap;
	int listgood;

	char *dbhome;
	int dbmode;
	int dbport;
	int dbtype;
	int mode;
	int ports;
	int reject_body;
	int reject_http;
	int reject_rdns;
	int reject_smtp;
	int reject_sock;
	int reject_trap;

	int level;
	int threads;
	int bitbucket;

	char *hostname;
	char **spamtrapuser;
	char **spamtrapdom;
	
	int strictsmtp;
	char *smtpmsg;
	
	int listenport;
	char *listenaddr;

	int targetport;
	char *targethost;

	int children;
	char *lockfile;

	exit_struct *exitval;
	ipc_struct *pipes;
	files_struct *file;
	child_struct **workers;
	child_struct *thread;
	test_struct **results;
	port_struct **port;
	dbctl_struct dbthread; 
	th_struct **testhost;

};

struct config_struct *config;
