#include "defines.h"
// #include <stdio.h>

// typedef struct db_struct db_struct;
typedef struct dbconf_struct dbconf_struct;

struct dbconf_struct {

	char *config;

	char *http;
	char *rdns;
	char *smtp;
	char *sock;
	char *trap;
	char *oklist;
	char *white;
	
	char *logfile;
	char *errfile;
	FILE *log;
	FILE *err;

	char *listenaddr;
	int listenport;
	int threads;
	int mode;

	char *lockfile;

	char *dbhome;
	int dbport;
	int dbmode;
	int dbtype;

};

typedef struct dbcon_struct dbcon_struct;

struct dbcon_struct {

	int type;
	char *host;
	int port;
	char *user;
	char *pass;
	char *name;
	char *unix_socket;

};


struct files_struct {

	char *http;
	char *rdns;
	char *smtp;
	char *sock;
	char *trap;
	char *localdb;
	char *oklist;
	char *white;

	FILE *logfp;
	FILE *errfp;

	char *logfile;
	char *errfile;

};

typedef struct dbctl_struct dbctl_struct;

struct dbctl_struct {
	int parentfd;
	int childfd;
};

typedef struct locks_struct locks_struct;

struct locks_struct {

	pthread_mutex_t http_lock;
	pthread_mutex_t smtp_lock;
	pthread_mutex_t sock_lock;
	pthread_mutex_t trap_lock;
	pthread_mutex_t white_lock;
	pthread_mutex_t local_lock;
	pthread_mutex_t oklist_lock;
};

struct conn_struct {

	int sd;
	int id;
	int query;
	int type;
	int port;
	int status;
	int result;
	char ipaddr[16];
	char *hostname;
	pthread_t tid;
	int dbthread[7];

};

typedef struct dbreq_struct dbreq_struct;

struct dbreq_struct {

	int id;
	int result;
	char ipaddr[16];
	int status;

	int type;
	int query;

	char *hostname;
	struct conn_struct *client;

};

struct db_struct {

	int rdnsfd;
	int trapfd;
	int relayfd;
	int proxyfd;
	int socksfd;
	int whitefd;
	int oklistfd;
	struct dbreq_struct req[MAX_REQUESTS];
	struct files_struct files;
	struct locks_struct locks;

} *dbinfo;

struct t_args {
	int id;
	int sd;
	char *ipaddr;
	char *hostname;
};

/*
int request[MAX_REQUESTS];
int thread_started;

struct conn_struct connection[MAX_REQUESTS];
struct dbreq_struct req[MAX_REQUESTS];
int debug=0;
int verbose=0;

struct dbconf_struct *config;
struct dbcon_struct *db;
*/
