/* Debug Header */
#if DEBUG
# define IFDEBUG(x) do { if (debug) x; }while(0)
# define IFDEBUG5(x) do { if (debug) x; }while(0)
#else
# define IFDEBUG(x)
# define IFDEBUG5(x)
#endif
/* End Debug Header */


#if HAVE_CONFIG_H
# include <config.h>
#endif

/* debug.c
 * 
 * any debug routines go here
 *
 */


#include <strings.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys/types.h>
#include "extern.h"
#include "defines.h"

void vprint_debug(int level, char *fmt, va_list args) {
	
	int d;
	char c, *p, *s;
	char *t, *str, *memp;

	memp=str=(char *)strdup(fmt);
	if (debug>=level) {
		fprintf(stdout, "Debug[%d]: ", level);
		while(*str) {
			t=str;
			t=(char *)strchr(t, '%');
			if (!t) break;
			*t='\0';
			if (str) fprintf(stdout, str);
			t++;
			str=t;
			switch(*str++) {
				case 's':
					s = va_arg(args, char *);
					fprintf(stdout, "%s", s);
					break;
				case 'i':
					d = va_arg(args, int);
					fprintf(stdout, "%i", d);
					break;
				case 'c':
					c = (char) va_arg(args, int);
					fprintf(stdout, "%c", c);
					break;
				case 'p':
					s = va_arg(args, char *);
					fprintf(stdout, "%p", s);
					break;
			}
		}
		if (str) fprintf(stdout, str);
		// printf("\n");
	}
	free(memp);
	fflush(stderr);
	fflush(stdout);
}

void print_debug(int level, const char *fmt, ...) {

	va_list va;

	va_start(va, fmt);
	vprint_debug(level, fmt, va);
	va_end(va);

}
