#ifndef CONFIG_FILE_NAME
# define CONFIG_FILE_NAME "/usr/local/etc/sockchk.conf"
#endif

#define FILE_BUF 8192
#define NET_BUFFER 8192
#define NET_TIMEOUT 10

#define NET_RTIMEOUT 45

#define NET_DTIMEOUT 10
#define PIPE_TIMEOUT 5
/* this is the time to wait for pipe checks */
#define SLEEP 60
/* this is the maximum number of workers to start */
#define MAX_WORKERS 25
/* Maximum requests to the db at any one time */
#define MAX_REQUESTS 20

#undef DEBUG

#ifdef HAVE_DMALLOC
#include "dmalloc.h"
#endif

#define FREE 0
#define CONNECTING 1
#define GO 1
#define BUSY 2
#define OK 3
#define GONE 255

#define NONE 0
#define CHECK 1
#define ADD 2
#define DEL 3
#define EXIT 4

#define IDLE 0
#define HTTP 1
#define SMTP 2
#define SOCKS 3
#define TRAP 4
#define WHITE 5
#define OKLIST 6
#define DONE 6
#define LOCALLIST 7
#define RDNS 8
#define NOT_FOUND 9
#define DELETED 100
#define ADDED 101
#define ADDPROB 102
#define DELPROB 103

#define ERROR -1
#define NOT_MATCHED 0
#define MATCHED 1
#define BAD 2
#define GOOD 3

/* Server Modes */
#define STANDALONE 0
#define DAEMON 1

/* static port allocation.... */
#define MAX_HTTPPORTS 10
#define MAX_SOCKSPORTS 10

/* Default lock location and name */
#define SEM_LOCK "/tmp/sockchk.lock"

/* db type definitions */
#define LOCAL_DB 1
#define MYSQL_DB 2
#define PGSQL_DB 3
#define MSQL_DB 4
#define IODBC_DB 5
#define UNIXODBC_DB 6
#define DB2_DB 7
#define SOLID_DB 8
#define OPENLINK_DB 9
#define EASYSOFT_DB 10
#define SAPDB_DB 11
#define IBASE_DB 12
#define CTLIB_DB 13
#define ORACLE8_DB 14
#define ORACLE7_DB 15

/* query type shortcuts */
#define SELECT_ALL_BY_ADDRESS 0
#define INSERT_VALUES 1
#define UPDATE_SET_WHERE 2
#define SELECT_ALL_BY_IP 3
#define SELECT_ALL_BY_IP_AND_ADDRESS 4
#define SELECT_FROM 5
#define SELECT_FROM_WHERE_LIKE 6
